// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.20.0
// source: locations.sql

package db

import (
	"context"
	"database/sql"
)

const createLocation = `-- name: CreateLocation :exec
INSERT INTO locations(
  address,
  name,
  submitted_by,
  regency_id,
  google_maps_link
) values (
  $1, $2, $3, $4, $5
)
`

type CreateLocationParams struct {
	Address        string         `json:"address"`
	Name           string         `json:"name"`
	SubmittedBy    int32          `json:"submitted_by"`
	RegencyID      int16          `json:"regency_id"`
	GoogleMapsLink sql.NullString `json:"google_maps_link"`
}

func (q *Queries) CreateLocation(ctx context.Context, arg CreateLocationParams) error {
	_, err := q.db.ExecContext(ctx, createLocation,
		arg.Address,
		arg.Name,
		arg.SubmittedBy,
		arg.RegencyID,
		arg.GoogleMapsLink,
	)
	return err
}

const getListLocations = `-- name: GetListLocations :many
SELECT id, address, name, google_maps_link, submitted_by, total_visited, thumbnail, regency_id, is_deleted, created_at, updated_at, approved_by, approved_at FROM locations
LIMIT $1
OFFSET $2
`

type GetListLocationsParams struct {
	Limit  int32 `json:"limit"`
	Offset int32 `json:"offset"`
}

func (q *Queries) GetListLocations(ctx context.Context, arg GetListLocationsParams) ([]Location, error) {
	rows, err := q.db.QueryContext(ctx, getListLocations, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	items := []Location{}
	for rows.Next() {
		var i Location
		if err := rows.Scan(
			&i.ID,
			&i.Address,
			&i.Name,
			&i.GoogleMapsLink,
			&i.SubmittedBy,
			&i.TotalVisited,
			&i.Thumbnail,
			&i.RegencyID,
			&i.IsDeleted,
			&i.CreatedAt,
			&i.UpdatedAt,
			&i.ApprovedBy,
			&i.ApprovedAt,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const getLocation = `-- name: GetLocation :one
SELECT id, address, name, google_maps_link, submitted_by, total_visited, thumbnail, regency_id, is_deleted, created_at, updated_at, approved_by, approved_at FROM locations
WHERE id = $1
`

func (q *Queries) GetLocation(ctx context.Context, id int32) (Location, error) {
	row := q.db.QueryRowContext(ctx, getLocation, id)
	var i Location
	err := row.Scan(
		&i.ID,
		&i.Address,
		&i.Name,
		&i.GoogleMapsLink,
		&i.SubmittedBy,
		&i.TotalVisited,
		&i.Thumbnail,
		&i.RegencyID,
		&i.IsDeleted,
		&i.CreatedAt,
		&i.UpdatedAt,
		&i.ApprovedBy,
		&i.ApprovedAt,
	)
	return i, err
}
